<template>
  <section>
    <div class="columns is-centered">
      <div class="column is-half has-text-centered">
        <div class="container image is-64x64 mb-2">
          <Avatar :value="id" />
        </div>
        <h1 class="title is-2">
          <a
            :href="`https://kusama.subscan.io/account/${id}`"
            target="_blank"
            rel="noopener noreferrer">
            <Identity
              ref="identity"
              :address="id"
              inline
              emit
              @change="handleIdentity" />
          </a>
        </h1>

        <span v-if="!displayName">
          Add on-chain recognition for
          <nuxt-link :to="`/identity`">
            {{ shortendId }}
          </nuxt-link>
        </span>
      </div>
    </div>

    <div class="columns is-mobile">
      <div class="column">
        <div class="label">
          {{ $t('profile.user') }}
        </div>
        <div class="subtitle is-size-6">
          <ProfileLink :address="id" :inline="true" showTwitter showDiscord />
        </div>
      </div>
    </div>

    <section>
      <b-tabs
        :class="{ 'invisible-tab': sharingVisible }"
        class="tabs-container-mobile"
        v-model="activeTab"
        destroy-on-hide
        expanded>
        <b-tab-item
          value="nft"
          :headerClass="{ 'is-hidden': !totalCollections }">
          <template #header>
            <b-tooltip
              :label="`${$t('tooltip.created')} ${labelDisplayName}`"
              append-to-body>
              {{ $t('profile.created') }}
              <span class="tab-counter" v-if="totalCreated">{{
                totalCreated
              }}</span>
            </b-tooltip>
          </template>
          <PaginatedCardList
            :id="id"
            :query="nftListByIssuer"
            @change="totalCreated = $event"
            :account="id"
            :showSearchBar="true" />
        </b-tab-item>
        <b-tab-item
          :label="`Collections - ${totalCollections}`"
          value="collection"
          :headerClass="{ 'is-hidden': !totalCollections }">
          <template #header>
            <b-tooltip
              :label="`${$t('tooltip.collections')} ${labelDisplayName}`"
              append-to-body>
              {{ $t('Collections') }}
              <span class="tab-counter" v-if="totalCollections">{{
                totalCollections
              }}</span>
            </b-tooltip>
          </template>
          <div class="is-flex is-justify-content-flex-end">
            <Layout class="mr-5" />
            <Pagination
              hasMagicBtn
              replace
              :total="totalCollections"
              v-model="currentCollectionPage" />
          </div>
          <GalleryCardList
            :items="collections"
            type="collectionDetail"
            route="/rmrk/collection"
            link="rmrk/collection"
            horizontalLayout />
          <Pagination
            replace
            class="pt-5 pb-5"
            :total="totalCollections"
            v-model="currentCollectionPage" />
        </b-tab-item>
        <b-tab-item
          value="sold"
          :headerClass="{ 'is-hidden': !totalCollections }">
          <template #header>
            <b-tooltip
              :label="`${$t('tooltip.sold')} ${labelDisplayName}`"
              append-to-body>
              {{ $t('profile.sold') }}
              <span class="tab-counter" v-if="totalSold">{{ totalSold }}</span>
            </b-tooltip>
          </template>
          <PaginatedCardList
            :id="id"
            :query="nftListSold"
            @change="totalSold = $event"
            :account="id"
            showSearchBar />
        </b-tab-item>
        <b-tab-item value="collected">
          <template #header>
            <b-tooltip
              :label="`${$t('tooltip.collected')} ${labelDisplayName}`"
              append-to-body>
              {{ $t('profile.collected') }}
              <span class="tab-counter" v-if="totalCollected">{{
                totalCollected
              }}</span>
            </b-tooltip>
          </template>
          <PaginatedCardList
            :id="id"
            :query="nftListCollected"
            @change="totalCollected = $event"
            :account="id"
            showSearchBar />
        </b-tab-item>
        <b-tab-item value="holdings">
          <template #header>
            <b-tooltip
              :label="`${$t('tooltip.holdings')} ${displayName}`"
              append-to-body>
              {{ $t('profile.holdings') }}
            </b-tooltip>
          </template>
          <Holding :account-id="id" />
        </b-tab-item>
      </b-tabs>
    </section>
  </section>
</template>

<script lang="ts">
import { Component, mixins, Watch } from 'nuxt-property-decorator'
import { notificationTypes, showNotification } from '@/utils/notification'
import { sanitizeIpfsUrl, fetchNFTMetadata } from '@/components/rmrk/utils'
import { CollectionWithMeta, Pack } from '@/components/rmrk/service/scheme'
import isShareMode from '@/utils/isShareMode'
import shouldUpdate from '@/utils/shouldUpdate'
import shortAddress from '@/utils/shortAddress'
import nftListByIssuer from '@/queries/nftListByIssuer.graphql'
import nftListCollected from '@/queries/nftListCollected.graphql'
import nftListSold from '@/queries/nftListSold.graphql'
import firstNftByIssuer from '@/queries/firstNftByIssuer.graphql'
import PrefixMixin from '@/utils/mixins/prefixMixin'
import collectionListByAccount from '@/queries/rmrk/subsquid/collectionListByAccount.graphql'
import { Debounce } from 'vue-debounce-decorator'

const components = {
  GalleryCardList: () =>
    import('@/components/rmrk/Gallery/GalleryCardList.vue'),
  Sharing: () => import('@/components/rmrk/Gallery/Item/Sharing.vue'),
  Identity: () => import('@/components/shared/format/Identity.vue'),
  Pagination: () => import('@/components/rmrk/Gallery/Pagination.vue'),
  PaginatedCardList: () =>
    import('@/components/rmrk/Gallery/PaginatedCardList.vue'),
  DonationButton: () => import('@/components/transfer/DonationButton.vue'),
  Avatar: () => import('@/components/shared/Avatar.vue'),
  ProfileLink: () => import('@/components/rmrk/Profile/ProfileLink.vue'),
  Layout: () => import('@/components/rmrk/Gallery/Layout.vue'),
  Holding: () => import('@/components/rmrk/Gallery/Holding.vue'),
}

@Component<Profile>({
  name: 'Profile',
  head() {
    const title = 'NFT Artist Profile on KodaDot'
    const metaData = {
      title,
      type: 'profile',
      description:
        this.firstNFTData.description || 'Find more NFTs from this creator',
      url: `/westmint/u/${this.id}`,
      image: this.firstNFTData.image || this.defaultNFTImage,
    }
    return {
      title,
      meta: [...this.$seoMeta(metaData)],
    }
  },
  components,
})
export default class Profile extends mixins(PrefixMixin) {
  public firstNFTData: any = {}
  protected id = ''
  protected shortendId = ''
  protected isLoading = false
  protected collections: CollectionWithMeta[] = []
  protected packs: Pack[] = []
  protected name = ''
  // protected property: {[key: string]: any} = {};
  protected email = ''
  protected twitter = ''
  protected displayName = ''
  protected web = ''
  protected legal = ''
  protected riot = ''
  private currentValue = 1
  private first = 20
  private total = 0
  private currentCollectionPage = 1
  protected totalCollections = 0
  protected totalCreated = 0
  protected totalCollected = 0
  protected totalSold = 0
  protected networks = [
    {
      url: 'https://dotscanner.com/Kusama/account/',
      als: 'dotscanner',
      img: '/dotscanner.svg',
    },
    {
      url: 'https://sub.id/#/',
      als: 'subid',
      img: '/subid.svg',
    },
    {
      url: 'https://kusama.subscan.io/account/',
      als: 'subscan',
      img: '/subscan.svg',
    },
    {
      url: 'https://polkascan.io/kusama/account/',
      als: 'polkascan',
      img: '/polkascan.png',
    },
  ]

  readonly nftListByIssuer = nftListByIssuer
  readonly nftListCollected = nftListCollected
  readonly nftListSold = nftListSold

  public async mounted() {
    await this.fetchProfile()
  }

  public checkId() {
    if (this.$route.params.id) {
      this.id = this.$route.params.id
      this.shortendId = shortAddress(this.id)
    }
  }

  get activeTab(): string {
    return (this.$route.query.tab as string) || 'nft'
  }

  set activeTab(val) {
    this.$route.query.page = ''
    this.$router.replace({
      query: { tab: val },
    })
  }

  get sharingVisible(): boolean {
    return isShareMode
  }

  get customUrl(): string {
    return `${window.location.origin}${this.$route.path}/${this.activeTab}`
  }

  get labelDisplayName(): string {
    return this.displayName ?? this.shortendId
  }

  get iframeSettings(): { width: string; height: string; customUrl: string } {
    return { width: '100%', height: '100vh', customUrl: this.customUrl }
  }

  get offset(): number {
    return this.currentValue * this.first - this.first
  }

  get collectionOffset(): number {
    return this.currentCollectionPage * this.first - this.first
  }

  get defaultNFTImage(): string {
    const url = new URL(window.location.href)
    return `${url.protocol}//${url.hostname}/https://secretmag.ru/imgs/2021/03/25/13/4577947/1d79f694a1edc20101d5e8b348013c05d5799219.gif`
  }

  protected async fetchProfile() {
    this.checkId()

    try {
      this.fetchCollectionList()

      this.$apollo.addSmartQuery('firstNft', {
        query: firstNftByIssuer,
        client: this.urlPrefix,
        manual: true,
        loadingKey: 'isLoading',
        result: this.handleResult,
        variables: () => {
          return {
            account: this.id,
          }
        },
        fetchPolicy: 'cache-and-network',
      })

      // this.packs = await rmrkService
      //   .getPackListForAccount(this.id)
      //   .then(defaultSortBy);
      // this.$consola.log(packs)
    } catch (e) {
      showNotification(`${e}`, notificationTypes.danger)
      this.$consola.warn(e)
    }
    // this.isLoading = false;
  }

  @Debounce(100)
  private async fetchCollectionList() {
    if (!this.id) {
      this.checkId()
    }
    const result = await this.$apollo.query({
      query: collectionListByAccount,
      client: this.urlPrefix === 'rmrk' ? 'subsquid' : this.urlPrefix,
      variables: {
        account: this.id,
        offset: this.collectionOffset,
        first: this.first,
      },
    })
    this.handleCollectionResult(result)
  }

  protected async handleResult({ data }: any) {
    if (!this.firstNFTData.image && data) {
      const nfts = data.nFTEntities.nodes
      if (nfts?.length) {
        const meta = await fetchNFTMetadata(nfts[0])
        this.firstNFTData = {
          ...meta,
          image: sanitizeIpfsUrl(meta.image || ''),
        }
      }
    }
  }

  protected async handleCollectionResult({ data }: any) {
    if (data) {
      this.totalCollections = data.stats.totalCount
      this.collections = data.collectionEntities
    }
    // in case user is only a collector, set tab to collected
    if (this.totalCollections === 0 && this.activeTab !== 'holdings') {
      this.$router
        .replace({ query: { tab: 'collected' } })
        .catch(this.$consola.warn /*Navigation Duplicate err fix later */)
    }
  }

  protected handleIdentity(identityFields: Record<string, string>) {
    this.displayName = identityFields?.display as string
    this.email = identityFields?.email as string
    this.twitter = identityFields?.twitter as string
    this.riot = identityFields?.riot as string
    this.web = identityFields?.web as string
    this.legal = identityFields?.legal as string
  }

  @Watch('$route.params.id')
  protected onIdChange(val: string, oldVal: string) {
    if (shouldUpdate(val, oldVal)) {
      this.fetchProfile()
    }
  }
  @Watch('currentCollectionPage', { immediate: true })
  private handleCurrentPageChange(page: number) {
    if (page) {
      this.fetchCollectionList()
    }
  }
}
</script>

<style lang="scss" scoped>
@import '@/styles/variables';

.invisible-tab > nav.tabs {
  display: none;
}

.tab-counter::before {
  content: ' - ';
  white-space: pre;
}

.title {
  flex-grow: 0;
  flex-basis: auto;
}
</style>
